<template>
  <div id="printContent" ref="imageWrapper">
    <h3>生产计划表</h3>

    <el-table
      :data="SClist"
      style="width: 100%"
      :header-cell-style="{ 'text-align': 'center', fontSize: '20px' }"
    >
      <el-table-column label="生产计划表">
        <!-- <el-table-column
                  :prop="item.prop"
                  :label="item.label"
                  :key="index"
                  v-if="item"
                > -->
        <template v-for="(item, index) in tableHeader">
          <el-table-column
            :prop="item.prop"
            :label="item.label"
            :key="index"
            v-if="item"
          >
          </el-table-column>
        </template>
      </el-table-column>
    </el-table>
  </div>
</template>

<script>
const item = {
  name: "",
  birth: "",
  province: "",
  city: "",
  address: "",
  phone: "",
};
const header = {
  prop: "key",
  label: "自定义",
  editable: false,
  type: "input",
};
import { ref, reactive, onMounted } from "vue";
import { ElMessage } from "element-plus";
import { b1VoLast, b2VoLast } from "@/api/b";
import html2canvas from "html2canvas";
import docxtemplater from "docxtemplater";
import PizZip from "pizzip";
import JSZipUtils from "jszip-utils";
import { saveAs } from "file-saver";
export default {
  name: "",
  components: {},
  props: {},

  setup(props) {
    const tableHeader = reactive([
      {
        prop: "xianbie",
        label: "线别",
        editable: false,
        type: "text",
      },

      {
        prop: "dd_shijian",
        label: "下订单日期",
        editable: false,
        type: "input",
      },
      {
        prop: "shijian",
        label: "日期",
        editable: false,
        type: "input",
      },
      {
        prop: "gx",
        label: "罐型",
        editable: false,
        type: "text",
      },
      {
        prop: "cp",
        label: "产品名称",
        editable: false,
        type: "input",
      },
      {
        prop: "jhcl",
        label: "计划产量",
        editable: false,
        type: "input",
      },
      {
        prop: "wcl",
        label: "完成量",
        editable: false,
        type: "input",
      },
      {
        prop: "dd_cy",
        label: "订单差异",
        editable: false,
        type: "input",
      },
      {
        prop: "fhhl",
        label: "飞鹤货量",
        editable: false,
        type: "input",
      },
      {
        prop: "jhrq",
        label: "交货日期",
        editable: false,
        type: "input",
      },
      {
        prop: "fhrq",
        label: "发货日期",
        editable: false,
        type: "input",
      },
      {
        prop: "bh",
        label: "版号",
        editable: false,
        type: "input",
      },
      {
        prop: "gz",
        label: "盖子",
        editable: false,
        type: "input",
      },
      {
        prop: "state",
        label: "状态",
        editable: false,
        type: "input",
      },
      {
        prop: "bz",
        label: "备注",
        editable: false,
        type: "input",
      },
    ]);

    let tableData = reactive([]);

    const formInline = reactive({
      user: "",
      region: "",
    });
    const imageWrapper = ref(null);

    let headData = reactive({
      head: {},
    });
    let hanjiRdData = reactive({
      scjhList: {},
    });
    let SClist = ref([]);
    let hjData = ref({});
    let ssList = ref([]);
    const submitForm = () => {};

    const handleEdit = (row) => {
      row.editable = true;
    };
    const handleDelete = (index) => {
      this.tableData.splice(index, 1);
    };
    const prepend = (index) => {
      item.editable = true;
      this.tableData.splice(index, 0, item);
    };
    const append = (index) => {
      item.editable = true;
      this.tableData.splice(index + 1, 0, item);
    };
    const deleteCurrentColumn = (index) => {
      this.tableHeader.splice(index, 1);
    };
    const insertBefore = (index) => {
      header.editable = true;
      this.tableHeader.splice(index, 0, header);
    };
    const getListData = async () => {
      const data = await b1VoLast();
      console.log("生产计划。。。", data);
      headData.head = data.data.head;
      hanjiRdData.scjhList = data.data.scjhList;

      hjData.value = {
        ...headData.head,
        ...hanjiRdData.scjhList,
      };

      // tableHeader.forEach(e=>{
      //   // SClist.push({e.})
      // })

      SClist.value = data.data.scjhList;

      // console.log(SClist);
    };

    const saveData = async () => {
      editable = false;

      let data = {
        scjhList: SClist.value,

        head: headData.head,
      };
      // console.log("save data...", data);
      const dt = await save(data);
      if (dt.code == 0) {
        ElMessage({
          message: "修改成功",
          type: "success",
        });
      }
      // console.log(dt);
    };
    //截图
    const toImage = () => {
      html2canvas(imageWrapper.value, {
        logging: false,
        allowTaint: true,
        scale: window.devicePixelRatio,
        // width: shareContent.clientWidth, //dom 原始宽度
        // height: shareContent.clientHeight,
        scrollY: 0,
        scrollX: 0,
        useCORS: true,
        backgroundColor: "#ffffff",
      }).then(function (canvas) {
        // console.log(canvas);
        let imgUrl = canvas.toDataURL("image/png");
        var tempLink = document.createElement("a"); // 创建一个a标签
        tempLink.style.display = "none";
        tempLink.href = imgUrl;
        tempLink.setAttribute("download", "焊机/后道工序生产质量记录"); // 给a标签添加下载属性
        if (typeof tempLink.download === "undefined") {
          tempLink.setAttribute("target", "_blank");
        }
        document.body.appendChild(tempLink); // 将a标签添加到body当中
        tempLink.click(); // 启动下载
        document.body.removeChild(tempLink); // 下载完毕删除a标签
        window.URL.revokeObjectURL(imgUrl);
      });
    };
    // 点击导出word
    function exportWord() {
      // 读取并获得模板文件的二进制内容
      JSZipUtils.getBinaryContent("hj.docx", function (error, content) {
        // input.docx是模板。我们在导出的时候，会根据此模板来导出对应的数据
        // 抛出异常
        if (error) {
          throw error;
        }

        // 创建一个JSZip实例，内容为模板的内容
        let zip = new PizZip(content);
        // 创建并加载docxtemplater实例对象
        let doc = new docxtemplater().loadZip(zip);
        // 设置模板变量的值
        doc.setData({
          ...hjData.value,

          // table: hanjiRdData.hanjiRd,
        });

        try {
          // 用模板变量的值替换所有模板变量
          doc.render();
        } catch (error) {
          // 抛出异常
          let e = {
            message: error.message,
            name: error.name,
            stack: error.stack,
            properties: error.properties,
          };
          // console.log(JSON.stringify({ error: e }));
          throw error;
        }

        // 生成一个代表docxtemplater对象的zip文件（不是一个真实的文件，而是在内存中的表示）
        let out = doc.getZip().generate({
          type: "blob",
          mimeType:
            "application/vnd.openxmlformats-officedocument.wordprocessingml.document",
        });
        // 将目标文件对象保存为目标类型的文件，并命名
        saveAs(out, "焊机/后道工序生产质量记录.docx");
      });
    }
    getListData();
    onMounted(() => {});
    return {
      b1VoLast,
      saveData,
      submitForm,
      formInline,
      tableData,
      insertBefore,
      deleteCurrentColumn,
      append,
      prepend,
      handleDelete,
      handleEdit,
      tableHeader,
      getListData,
      headData,
      toImage,
      imageWrapper,
      SClist,
      ssList,
      exportWord,
    };
  },
};
</script>
<style lang="scss" scoped>
.header_nox {
  text-align: right;
}
#printContent h3 {
  text-align: center;
  margin-bottom: 40px;
  font-size: 26px;
  font-weight: bold;
}
.title_form {
  display: flex;
  justify-content: space-around;
  align-items: center;
  // margin-bottom: 20px;
}
.title_form_input {
  font-size: 16px;
}
</style>
